#!/usr/bin/env python

import logging
import logging.handlers
import sys

import config_server

from hashlib import sha256
from dcnow import DreamcastNowService

dns_query = None
dreamcast_ip = None

def print_menu(): 
    print 30 * "-" , "SELECT GAME" , 30 * "-"
    print "0. (None)"
    print "1. Phantasy Star Online"
    print "2. Quake 3 Arena"
    print "3. 4x4 Evolution"
    print "4. Maximum Pool"
    print "5. Starlancer"
    print "6. Planet Ring"
    print "7. Toy Racer"
    print "8. Chu Chu Rocket!"
    print "9. The Next Tetris: Online Edition"
    print "10. Alien Front Online"
    print "11. Worms World Party"
    print "12. Monaco Grand Prix On-Line / Pod 2"
    print "13. Ooga Booga"
    print "14. WSB 2K2"
    print "15. NFL 2K1"
    print "16. NFL 2K2"
    print "17. NCAA 2K2"
    print "18. NBA 2K1"
    print "19. NBA 2K2"
    print "20. PBA Tour Bowling 2001 (DCNOW)"
    print "21. Virtua Tennis (JP) - EXPERIMENTAL"
    print "22. Jet Set Radio - EXPERIMENTAL"
    print "23. Metropolis Street Racing"
    print "24. Sonic Adventure"
    print "25. Sonic Adventure 2"
    print "26. Crazy Taxi 2"
    print "27. SEGA GT"
    print "28. Ferrari F355 Challenge"
    print "29. Exit"
    print 67 * "-"


logger = logging.getLogger('dcnow')
logger.setLevel(logging.INFO)
logger.addHandler(logging.StreamHandler())

print("Welcome to DCNow!")
print("Connecting...")

config_server.start()
dcnow = DreamcastNowService()
dcnow.go_online(dreamcast_ip)
	
print("Connected!")

loop=True      

while loop:
    print_menu()
    choice = input("Enter your choice [0-29]: ")
    
    if choice==0:
        dns_query = None
    elif choice==1:
	#dns_query = sha256("auth01.dricas.com").hexdigest()
        dns_query = sha256("master.pso.dream-key.com").hexdigest()
    elif choice==2:
	dns_query = sha256("master.id-q3a.games.sega.net").hexdigest()
    elif choice==3:
	dns_query = sha256("master.4x4evolution.com").hexdigest()
    elif choice==4:
        dns_query = sha256("coolpool.west.won.net").hexdigest()
    elif choice==5:
        dns_query = sha256("master.gamespy.com").hexdigest()
    elif choice==6:
	dns_query = sha256("master.ring.dream-key.com").hexdigest()
    elif choice==7:
	dns_query = sha256("gamesauth.dream-key.com").hexdigest()
    elif choice==8:
	dns_query = sha256("chuchu.games.dream-key.com").hexdigest()
    elif choice==9:
	dns_query = sha256("peerchat.gamespy.com").hexdigest()
    elif choice==10:
	dns_query = sha256("auriga.segasoft.com").hexdigest()
    elif choice==11:
	dns_query = sha256("master.worms.dream-key.com").hexdigest()
    elif choice==12:
	dns_query = sha256("connect.gameloft.com").hexdigest()
    elif choice==13:
	dns_query = sha256("authorize.vc-ooga.games.sega.net").hexdigest()
    elif choice==14:
	dns_query = sha256("authorize.vc-wsb2k2.games.sega.net").hexdigest()
    elif choice==15:
	dns_query = sha256("AUTHORIZE.VC-NFL2K1.GAMES.SEGA.COM").hexdigest()
    elif choice==16:
	dns_query = sha256("AUTHORIZE.VC-NFL2K2.GAMES.SEGA.COM").hexdigest()
    elif choice==17:
	dns_query = sha256("AUTHORIZE.VC-NCAA2K2.GAMES.SEGA.COM").hexdigest()
    elif choice==18:
	dns_query = sha256("AUTHORIZE.VC-NBA2K1.GAMES.SEGA.COM").hexdigest()
    elif choice==19:
	dns_query = sha256("AUTHORIZE.VC-NBA2K2.GAMES.SEGA.COM").hexdigest()
    elif choice==20:
	dns_query = sha256("master.pba2001.com").hexdigest()
    elif choice==21:
	dns_query = sha256("powsmash.dricas.ne.jp").hexdigest()
    elif choice==22:
	dns_query = sha256("jetsetradio.dreampipe.net").hexdigest()
    elif choice==23:
	dns_query = sha256("metropolis.dream-key.com").hexdigest()
    elif choice==24:
	dns_query = sha256("sonic.games.dreamcast.com").hexdigest()
    elif choice==25:
	dns_query = sha256("sonic2.dricas.ne.jp").hexdigest()
    elif choice==26:
	dns_query = sha256("ct2.hitmaker.co.jp").hexdigest()
    elif choice==27:
	dns_query = sha256("segagt.web.dreamcast.com").hexdigest()
    elif choice==28:
	dns_query = sha256("www.sega-rd2.com").hexdigest()
    elif choice==29:
	loop=False
    else:
	raw_input("Wrong option selection...")

    if loop==True:
	dcnow.set_game(dns_query)

print("Disconnecting...")
dcnow.go_offline()
config_server.stop()

sys.exit(0)
